/**
 * debounce prevents a particular function from being called until after a given
 * cooldown period (default 100ms). Every time the function is called, it resets
 * the cooldown.
 */
export default function debounce(fn, threshhold) {
    if (threshhold === void 0) { threshhold = 100; }
    var deferTimer;
    var debounced = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (deferTimer) {
            clearTimeout(deferTimer);
        }
        deferTimer = setTimeout(function () {
            deferTimer = null;
            fn.apply(void 0, args);
        }, threshhold);
    };
    debounced.clearTimeout = function () {
        if (deferTimer) {
            clearTimeout(deferTimer);
        }
    };
    return debounced;
}
//# sourceMappingURL=debounce.js.map