var mindex = function (arr) {
    var idx = 0;
    for (var i = 1; i < arr.length; i++) {
        if (arr[i] < arr[idx]) {
            idx = i;
        }
    }
    return idx;
};
var offscreen = function (width, height) {
    if (height === void 0) { height = Infinity; }
    return ({
        top: -9999,
        left: -9999,
        width: width,
        height: height,
    });
};
export default (function (_a) {
    var cache = _a.cache, _b = _a.columnWidth, columnWidth = _b === void 0 ? 236 : _b, _c = _a.gutter, gutter = _c === void 0 ? 14 : _c, _d = _a.minCols, minCols = _d === void 0 ? 2 : _d, width = _a.width;
    return function (items) {
        if (width == null) {
            return items.map(function () { return offscreen(columnWidth); });
        }
        var columnWidthAndGutter = columnWidth + gutter;
        var columnCount = Math.max(Math.floor((width + gutter) / columnWidthAndGutter), minCols);
        // the total height of each column
        var heights = new Array(columnCount).fill(0);
        var centerOffset = Math.max(Math.floor((width - columnWidthAndGutter * columnCount + gutter) / 2), 0);
        return items.reduce(function (acc, item) {
            var positions = acc;
            var height = cache.get(item);
            var position;
            if (height == null) {
                position = offscreen(columnWidth);
            }
            else {
                var heightAndGutter = height + gutter;
                var col = mindex(heights);
                var top_1 = heights[col];
                var left = col * columnWidthAndGutter + centerOffset;
                heights[col] += heightAndGutter;
                position = { top: top_1, left: left, width: columnWidth, height: height };
            }
            positions.push(position);
            return positions;
        }, []);
    };
});
//# sourceMappingURL=defaultLayout.js.map