var mindex = function (arr) {
    var idx = 0;
    for (var i = 1; i < arr.length; i++) {
        if (arr[i] < arr[idx]) {
            idx = i;
        }
    }
    return idx;
};
export default (function (_a) {
    var _b = _a.gutter, gutter = _b === void 0 ? 0 : _b, cache = _a.cache, _c = _a.minCols, minCols = _c === void 0 ? 2 : _c, _d = _a.idealColumnWidth, idealColumnWidth = _d === void 0 ? 240 : _d, width = _a.width;
    if (width == null) {
        return function (items) {
            return items.map(function () { return ({
                top: Infinity,
                left: Infinity,
                width: Infinity,
                height: Infinity,
            }); });
        };
    }
    // "This is kind of crazy!" - you
    // Yes, indeed. The "guessing" here is meant to replicate the pass that the
    // original implementation takes with CSS.
    var colguess = Math.floor(width / idealColumnWidth);
    var columnCount = Math.max(Math.floor((width - colguess * gutter) / idealColumnWidth), minCols);
    var columnWidth = Math.floor(width / columnCount);
    return function (items) {
        // the total height of each column
        var heights = new Array(columnCount).fill(0);
        return items.reduce(function (acc, item) {
            var positions = acc;
            var height = cache.get(item);
            var position;
            if (height == null) {
                position = {
                    top: Infinity,
                    left: Infinity,
                    width: columnWidth,
                    height: Infinity,
                };
            }
            else {
                var col = mindex(heights);
                var top_1 = heights[col];
                var left = col * columnWidth + gutter / 2;
                heights[col] += height;
                position = {
                    top: top_1,
                    left: left,
                    width: columnWidth - gutter,
                    height: height,
                };
            }
            positions.push(position);
            return positions;
        }, []);
    };
});
//# sourceMappingURL=fullWidthLayout.js.map