var offscreen = function (width, height) {
    if (height === void 0) { height = Infinity; }
    return ({
        top: -9999,
        left: -9999,
        width: width,
        height: height,
    });
};
export default (function (_a) {
    var cache = _a.cache, _b = _a.columnWidth, columnWidth = _b === void 0 ? 236 : _b, _c = _a.gutter, gutter = _c === void 0 ? 14 : _c, width = _a.width, _d = _a.minCols, minCols = _d === void 0 ? 3 : _d;
    return function (items) {
        if (width == null) {
            return items.map(function () { return offscreen(columnWidth); });
        }
        var columnWidthAndGutter = columnWidth + gutter;
        var columnCount = Math.max(Math.floor((width + gutter) / columnWidthAndGutter), minCols);
        var positions = [];
        var heights = [];
        for (var i = 0; i < items.length; i += 1) {
            var position = void 0;
            var height = cache.get(items[i]);
            if (height == null) {
                position = offscreen(columnWidth);
            }
            else {
                var column = i % columnCount;
                var row = Math.floor(i / columnCount);
                if (column === 0 || height > heights[row]) {
                    heights[row] = height;
                }
                var top_1 = row > 0
                    ? heights.slice(0, row).reduce(function (sum, y) { return sum + y + gutter; }, 0)
                    : 0;
                position = {
                    top: top_1,
                    left: column * columnWidthAndGutter,
                    width: columnWidth,
                    height: height,
                };
            }
            positions.push(position);
        }
        return positions;
    };
});
//# sourceMappingURL=uniformRowLayout.js.map